variables:
  DOCKER_DRIVER: overlay

stages:
  - image
  - deploy

build_image:
  stage: image
  image: docker:latest
  services:
    - docker:dind
  script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN ${CI_REGISTRY}
    - docker build -t ${CI_REGISTRY}/${CI_PROJECT_NAMESPACE}/${CI_PROJECT_NAME}:${CI_BUILD_REF_NAME} .
    - docker push ${CI_REGISTRY}/${CI_PROJECT_NAMESPACE}/${CI_PROJECT_NAME}:${CI_BUILD_REF_NAME}

deploy_prod:
  stage: deploy
  services:
    - docker:dind
  image: docker:latest
  script:
    - mkdir -p ~/.docker
    - echo "$TLSCACERT" > ~/.docker/ca.pem
    - echo "$TLSCERT" > ~/.docker/cert.pem
    - echo "$TLSKEY" > ~/.docker/key.pem
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN ${CI_REGISTRY}
    - docker -H tcp://$SWARM_HOST:$SWARM_PORT --tls stack deploy --with-registry-auth --compose-file docker-compose.yml snesup
  only:
    - master
  environment:
    name: prod
    url: http://snesup-forum.talcod-devs.ovh
